// #autoload
// #name = KmaThirdFlag
// #version = 1.0
// #date = 25 Feb 2002
// #author = KmA_Kaiten Commander
// #warrior =  Kaiten Commander
// #email = kaiten@cb-tribes.co.uk
// #web = http://www.clan-kma.com/
// #description = Switches to third person and back when you have grabbed the flag.
// #status = beta
// #include = support/team_tracker.cs
// #include = support/stat_support.cs
// #config = KmaThirdFlagConfig


if(!isObject(KmaThirdFlag))
{
	if(isFile("prefs/KmaThirdFlagPrefs.cs") && !$KmaThirdFlagLoaded)
	{
		exec("prefs/KmaThirdFlagPrefs.cs");
		$KmaThirdFlagLoaded = true;
	}

	new ScriptObject(KmaThirdFlag)
	{
		class = KmaThirdFlag;
		version = 1.0;
	};

	if($KmaThirdFlag::ThirdFlag::Version $= "")
	{
		$KmaThirdFlag::ThirdFlag::Version = KmaThirdFlag.version;
		$KmaThirdFlag::ThirdFlag::Enabled = true;
		$KmaThirdFlag::ThirdFlag::Time = 3000;
	}
}

// START package KmaThirdFlag
package KmaThirdFlag
{
    	function defaultMessageCallback(%msgType, %msgString, %a1, %a2, %a3, %a4, %a5, %a6, %a7, %a8, %a9, %a10)
    	{
        	if($KmaThirdFlag::ThirdFlag::Enabled)
        	{
        	    if (Strstr(%msgString, "You took") != -1)
        	        KmaThirdFlag.check(true);
        	}
        	parent::defaultMessageCallback(%msgType, %msgString, %a1, %a2, %a3, %a4, %a5, %a6, %a7, %a8, %a9, %a10);
	}
	
	function KmaThirdFlag::check(%this, %val)
	{
		if(%val)
		{
			if(!%this.active)
			{
				%this.firstPerson = $firstPerson;
				%this.active = true;
			}

			if($firstPerson)
			{
				$firstPerson = !$firstPerson;

				cancel(%this.scheduleCheck);
				%this.scheduleCheck = %this.schedule($KmaThirdFlag::ThirdFlag::Time, check, false);
			}
			else
				%this.active = false;
		}
		else
		{
			$firstPerson = %this.firstPerson;
			%this.active = false;
		}
	}

	function KmaThirdFlagToggle(%val)
	{
		if(%val)
		{
			$KmaThirdFlag::ThirdFlag::Enabled = !$KmaThirdFlag::ThirdFlag::Enabled;

			alxPlay(sButtonOver,0,0,0);

			if($KmaThirdFlag::ThirdFlag::Enabled)
				addMessageHudLine("\c2KmaThirdFlag enabled.");
			else
				addMessageHudLine("\c2KmaThirdFlag disabled.");
		}
	}

	function KmaThirdFlag::setup(%this)
	{
		
		if(%this.setup)
			return;

//		addMessageCallBack('MsgCTFFlagTaken', KmaThirdFlagGrab);

		new GuiControl(KmaThirdFlagConfig) {
			profile = "GuiDefaultProfile";
			horizSizing = "center";
			vertSizing = "center";
			position = "0 0";
			extent = "640 480";
			minExtent = "8 8";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";

			new ShellPaneCtrl() {
				profile = "ShellPaneProfile";
				horizSizing = "center";
				vertSizing = "center";
				position = "0 0";
				extent = "251 102";
				minExtent = "48 92";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
				text = "KmaThirdFlag";
				longTextBuffer = "0";
				maxLength = "255";
				noTitleBar = "0";

				new ShellFieldCtrl() {
					profile = "ShellFieldProfile";
					horizSizing = "right";
					vertSizing = "bottom";
					position = "20 29";
					extent = "211 53";
					minExtent = "16 18";
					visible = "1";
					hideCursor = "0";
					bypassHideCursor = "0";
					helpTag = "0";
				};
				new ShellSliderCtrl(KmaThirdFlagConfigSlider) {
					profile = "ShellSliderProfile";
					horizSizing = "right";
					vertSizing = "bottom";
					position = "33 50";
					extent = "186 24";
					minExtent = "12 24";
					visible = "1";
					hideCursor = "0";
					bypassHideCursor = "0";
					altCommand = "KmaThirdFlag.updateInterval();";
					variable = "value";
					helpTag = "0";
					range = "1000 4000";
					ticks = "1000";
					value = "1";
					usePlusMinus = "1";
				};
				new GuiTextCtrl(KmaThirdFlagConfigText) {
					profile = "ShellTextProfile";
					horizSizing = "right";
					vertSizing = "bottom";
					position = "67 35";
					extent = "109 22";
					minExtent = "8 8";
					visible = "1";
					hideCursor = "0";
					bypassHideCursor = "0";
					helpTag = "0";
					longTextBuffer = "0";
					maxLength = "255";
				};
			};
		};

		KmaThirdFlagConfigSlider.setValue($KmaThirdFlag::ThirdFlag::Time);
		%this.setup = true;
	}

	function KmaThirdFlag::updateInterval(%this)
	{
		$KmaThirdFlag::ThirdFlag::Time = KmaThirdFlagConfigSlider.getValue();
		KmaThirdFlagConfigText.setValue("Duration - " @ KmaThirdFlagConfigSlider.getValue() @ " ms");
	}

	function DispatchLaunchMode()
	{
		parent::DispatchLaunchMode();

		KmaThirdFlag.setup();
	}

	function OptionsDlg::onWake(%this)
	{
		if(!$KmaThirdFlagBind)
		{
			$RemapName[$RemapCount]="KmaThirdFlag Toggle";
			$RemapCmd[$RemapCount]="KmaThirdFlagToggle";
			$RemapCount++;

			$KmaThirdFlagBind = true;
		}

		parent::onWake(%this);
	}

	function quit()
	{
		if(!$KmaThirdFlagsSaved)
		{
			export("$KmaThirdFlag::*", "prefs/KmaThirdFlagPrefs.cs", false);
			$KmaThirdFlagsSaved = true;
		}

		parent::quit();
	}

// END package KmaThirdFlag
};
activatePackage(KmaThirdFlag);

if($AutoloadExecuted)
	KmaThirdFlag.setup();